"use strict";
(function(doc, win) {
    var $ = function(selector) { return doc.querySelectorAll(selector); }
    var $$ = function(selector) { return doc.querySelector(selector); }
    var menu = $$('#globalNaviAreaSection');
    var menus;
    var nodeList;
    var node;
    if(menu == null) {
        return;
    }
    //メニューにホバーした時にローカルメニューにクラスをつける
    menus = $$('#globalNaviAreaSection').querySelectorAll('.menuFirst > li');
    if(menus) {
        //polyfill for IE11
        node = Array.prototype.slice.call(menus, 0);
        node.forEach(function(elm) {
            var local = elm.querySelector('.menuSecond');
            if(local != null) {
                onEvent('mouseenter', elm, function() {
                    local.classList.add('show');
                });
                onEvent('mouseleave', elm, function() {
                    local.classList.remove('show');
                    local.classList.add('hide');
                });
                onEvent('animationend', local, function() {
                    local.classList.remove('hide');
                });
            }
        });
    }

    //ページトップに戻るボタン
    var supportPageOffset = window.pageXOffset !== undefined;
    var isCSS1Compat = ((document.compatMode || "") === "CSS1Compat");
    var pageTopShowPosition = $$('#pagetop a').getAttribute('data-offset') || 300;
    onEvent('scroll', win, function(e) {
        var y = supportPageOffset ? window.pageYOffset : isCSS1Compat ? document.documentElement.scrollTop : document.body.scrollTop;
        if(~~pageTopShowPosition <= y) {
            $$('#pagetop').classList.remove('hide');
            $$('#pagetop').classList.add('show');
            if($$('.pagetop2')) {
                $$('.pagetop2').classList.remove('hide');
                $$('.pagetop2').classList.add('show');
            }
        } else {
            if($$('#pagetop').classList.contains('show')) {
                $$('#pagetop').classList.remove('show');
                $$('#pagetop').classList.add('hide');
                if($$('.pagetop2')) {
                    $$('.pagetop2').classList.remove('show');
                    $$('.pagetop2').classList.add('hide');
                }
            }
        }
    });

    //binding data
    nodeList = $('[data-bind]');
    if(nodeList) {
        node = Array.prototype.slice.call(nodeList, 0);
        node.forEach(function(elm) {
            var data = elm.getAttribute('data-bind');
            var ar = data.split(":");
            var rect = $$(ar[1]).getBoundingClientRect();

            var selector = (elm.id ? "#"+elm.id: "");

            elm.style[ar[0]] = rect[ar[2]]+"px";
        });
    }

    nodeList = $('[data-bind-attr]');
    if(nodeList) {
        node = Array.prototype.slice.call(nodeList, 0);
        node.forEach(function(elm) {
            var data = elm.getAttribute('data-bind-attr');
            var ar = data.split(":");
            var rect = $$(ar[1]).getBoundingClientRect();

            var selector = (elm.id ? "#"+elm.id: "");

            elm.setAttribute(ar[0], rect[ar[2]]);
        });
    }

    //Sticky Polyfill
    Stickyfill.add(document.querySelectorAll('.sticky'));

    //アンカーユニットへの対応
    nodeList = $('.bAnchorSide, .bAnchor');
    if(nodeList) {
        node = Array.prototype.slice.call(nodeList, 0);
        node.forEach(function(elm) {
            var easing = elm.getAttribute('data-easing');
            var speed = elm.getAttribute('data-speed');
            var links = elm.querySelectorAll('a');
            var linkNode;
            if(easing=="" && links) {
                linkNode = Array.prototype.slice.call(links, 0);
                linkNode.forEach(function(link) {
                    onEvent('click', link, function(e){
                        var sel = this.href.split('#');
                        var offset, offsetTarget=document.querySelector('#globalNaviAreaSection.sticky, #anchorNaviArea.sticky');
                        sel = '#'+sel[1];
                        if(offsetTarget){
                            offset = offsetTarget.getAttribute('data-offset');
                        }

                        elementScrollToEasing(sel, 0, 'linear', offset||0);
                        e.preventDefault();
                        e.stopPropagation();
                    });
                });
            }
        });
    }

    //ユニットのCSSアニメーションへの対応
    if(j$("#items").length==0){
        j$("[class*=attach_anim]").addClass("anim");
        j$("[class*=attach_anim]").on("inview", function(e, view){
            if(view && j$(this).hasClass("attach_anim")) {
                var match = j$(this).attr('class').match(/(attach_[a-zA-Z]+)/g);
                if(match) {
                    for(var i = 0; i < match.length; i++) {
                        j$(this).addClass(match[i].replace('attach_', ''));
                    }
                    j$(this).addClass('animated');
                }
            }
        });
    }
})(document, window);
